# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as 
# published by the Free Software Foundation here:
# (http://www.gnu.org/licenses/gpl-2.0.html)
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

export DEPENDS = glibc
export ARCH = x86_64
export URL = https://www.isc.org/
SNAPVER = 2

PWD := $(shell pwd)
ROOT := $(PWD)/ROOT
ARCHIVE := $(PWD)/SRC/$(shell ls SRC|egrep '(bz2|gz|tar|xz)$$'|tail -1)
TYPE := $(shell file -ib $(ARCHIVE)|cut -d';' -f1|tr -d '\n')
SRCDIR := $(shell tar -tf $(ARCHIVE)|head -1|sed 's/\/.*//')
PATCHDIR := $(PWD)/SRC/patches
export VERSION := $(shell echo $(SRCDIR)|egrep -o '\-[0-9].*'| \
	sed 's/^-//')$(SNAPVER)

DHCLIENT := $(PWD)/dhclient
export DHCLIENTROOT := $(DHCLIENT)/ROOT
DHCPD := $(PWD)/dhcpd
export DHCPDROOT := $(DHCPD)/ROOT

$(DHCPDROOT): $(DHCLIENTROOT)
	@install -v -d $(DHCPD)/SNAP && \
	install -v -d $(DHCPDROOT)
	@cd $(SRCDIR) && make -C server install DESTDIR=$(DHCPDROOT)
	@cd $(DHCPD) && make -f ../Makefile.dhcpd && \
		mv *.snap ../

$(DHCLIENTROOT): $(SRCDIR)/client/dhclient
	@install -v -d $(DHCLIENT)/SNAP && \
	install -v -d $(DHCLIENTROOT)
	@cd $(SRCDIR) && make -C client install DESTDIR=$(DHCLIENTROOT)
	@install -v -m 755 $(SRCDIR)/client/scripts/linux \
		$(DHCLIENTROOT)/sbin/dhclient-script
	@cd $(DHCLIENT) && make -f ../Makefile.dhclient && \
		mv *.snap ../

$(SRCDIR)/configure: $(ARCHIVE)
	@if [ '$(TYPE)' == 'application/x-bzip2' ]; then \
		tar -jxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-gzip' ]; then \
		tar -zxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-tar' ]; then \
		tar -xf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-xz' ]; then \
		tar -xf $(ARCHIVE); \
	else \
		echo 'Unable to determine archive type'; \
		exit 1; \
	fi
	@touch $(SRCDIR)/configure

$(SRCDIR)/config.log: $(SRCDIR)/configure
	@cd $(SRCDIR) && \
	for patch in `find $(PATCHDIR) -name \*.patch|sort`; do \
		patch --verbose -Np1 -i $$patch; \
	done
	@cd $(SRCDIR); \
	./configure \
		--prefix=/usr \
		--sbindir=/sbin \
		--sysconfdir=/etc/dhcp \
		--build=x86_64-snap-linux-gnu \
		--host=x86_64-snap-linux-gnu \
		--target=x86_64-snap-linux-gnu

$(SRCDIR)/client/dhclient: $(SRCDIR)/config.log
	@cd $(SRCDIR) && make

test: $(DHCLIENTROOT) $(DHCPDROOT)
	@cd $(SRCDIR); \
	make check

clean:
	@rm -rvf $(ROOT) \
		$(DHCLIENT) \
		$(DHCPD) \
		$(SNAPINFO) \
		$(MANIFEST) \
		$(FILES) \
		$(SRCDIR)

